///////////////////////////////////////////////////////////////////////////////////////////
// MAT 259 Assignment 2: Reorderable Matrix
// Setup Function with different sorting methods
// by Nataly Moreno
///////////////////////////////////////////////////////////////////////////////////////////

int [] sumRows            = new int[numRows];
int [] trackRowChanges    = new int[numRows];

int [] sumColumns         = new int[numColumns];
int [] trackColumnChanges = new int[numColumns];

//the row stays the same for the chunky matrix
int [] sumChunkColumns    = new int[YEARS];
int [] trackChunkChanges  = new int[YEARS];

void setup()
{
  size(1190, 560);
  background(255);
  smooth();
  println("SetUp Done!");
  myTable = loadTable("XcelCombined.csv", "header");
  
  println("Rows: " + numRows);
  println("Columns: " + numColumns);
  
  dataMatrix    = new int[numRows][numColumns];
  drawMatrix    = new int[numRows][numColumns];
  chunkyMatrix  = new int[numRows][YEARS];
  
  int k = 0; //row
  int m = 0; //column
  
  //This ordering is by year and month, the way it is in the CSV file
  for(int i = 0; i < myTable.getRowCount(); i++)
  {
    for(int j = 2; j < myTable.getColumnCount(); j++)
    {   
      maxCheckOuts = max(myTable.getInt(i,j), maxCheckOuts);   
      dataMatrix[k][m] = myTable.getInt(i,j);
      drawMatrix[k][m] = myTable.getInt(i,j);
      k++;
      
      if(k == 15)
      {
        k = 0;
        m++;
      }
    }
  }
  
  //This makes the chunky matrix the way it is in the CSV file
  for(int i = 0; i < numRows; i++)
    for(int j = 0; j < YEARS; j++)
      chunkyMatrix[i][j] = 0;                   //clear the matrix
  
  //this is a sum of the column chunk itself
  //this treats a year as a column
  k = 0;
  m = 0;
  
  for(int i = 0; i < numRows; i++)
  {
    for(int j = 0; j < YEARS; j++)
    {
      for(int v = 0; v < 12; v++)
        chunkyMatrix[k][j] += dataMatrix[i][(j * 12) + v];
    }
    k++;
  }  
  
///////////////////////////////////////////////////////////////////////////////////////////
//Bubble Sort: Rows
//One iteration of bubble sort can not promise full sorting
//therefore, a while loop keeps the iterations going until 
//it is fully sorted.
///////////////////////////////////////////////////////////////////////////////////////////

  for(int i = 0; i < numRows; i++)
  {
    sumRows[i] = 0;         //initialize array to zero
    trackRowChanges[i] = i; //initialize array to i
    
    for(int j = 0; j < numColumns; j++) //add values in the same row
      sumRows[i] += dataMatrix[i][j];
  }
    
  //Reorder the Matrix by Rows
  int ordered = 0;     //0 = false, 1 = true
  
  while(ordered == 0)
  {
    ordered = 1;
    for(int i = 0; i < numRows - 1; i++)
    {   
      if(sumRows[trackRowChanges[i]] > sumRows[trackRowChanges[i + 1]])
      {      
        //track the change for it to be ordered
        int temp               = trackRowChanges[i];
        trackRowChanges[i]     = trackRowChanges[i + 1];
        trackRowChanges[i + 1] = temp;
        ordered = 0; //if it came here, it is not ordered
      }
    }
  }  //end when it is ordered
 
///////////////////////////////////////////////////////////////////////////////////////////
//Bubble Sort: Columns
///////////////////////////////////////////////////////////////////////////////////////////

  for(int i = 0; i < numColumns; i++)
  {
    sumColumns[i] = 0;
    trackColumnChanges[i] = i;
    
    for(int j = 0; j < numRows; j++)
      sumColumns[i] += dataMatrix[j][i];
    
  }
  
  ordered = 0;
  while(ordered == 0)
  {
    ordered = 1;
    for(int i = 0; i < numColumns - 1; i++)
    {
      if(sumColumns[trackColumnChanges[i]] > sumColumns[trackColumnChanges[i + 1]])
      {
        //track the order change - that is all that is needed
        int temp                  = trackColumnChanges[i];
        trackColumnChanges[i]     = trackColumnChanges[i + 1];
        trackColumnChanges[i + 1] = temp;
        ordered = 0; //it is not ordered if the code gets here
      }
    }
  }  //end when it is ordered
  
///////////////////////////////////////////////////////////////////////////////////////////
//Bubble Sort: Years (Column Chunks)
///////////////////////////////////////////////////////////////////////////////////////////

  for(int i = 0; i < YEARS; i++)
  {
    sumChunkColumns[i]   = 0;
    trackChunkChanges[i] = i;
    
    for(int j = 0; j < numRows; j++)
      sumChunkColumns[i] += chunkyMatrix[j][i];
    
  }
  
  ordered = 0;
  while(ordered == 0)
  {
    ordered = 1;
    for(int i = 0; i < YEARS - 1; i++)
    {
      if(sumChunkColumns[trackChunkChanges[i]] > sumChunkColumns[trackChunkChanges[i + 1]])
      {
        int temp                 = trackChunkChanges[i];
        trackChunkChanges[i]     = trackChunkChanges[i + 1];
        trackChunkChanges[i + 1] = temp;
        ordered = 0; //it is not ordered if the code gets here
      }
    }
  }  //end when it is ordered

} //end setup
















