///////////////////////////////////////////////////////////////////////////////////////////
// MAT 259 Assignment 2: Reorderable Matrix
// Key Pressed Function 
// by Nataly Moreno
///////////////////////////////////////////////////////////////////////////////////////////

void keyPressed()
{
  if(key == ' ')
    colorTheme = (colorTheme + 1) % 6;

  //original ordering
  if(key == 'o')
  {
    removeColumnLabels = 0;
    for(int i = 0; i < YEARS; i++)
      yearL[i] = origYearL[i];

    for(int i = 0; i < numRows; i++)
    {
      labels[i] = origLabels[i];
      
      for(int j = 0; j < numColumns; j++)
        drawMatrix[i][j] = dataMatrix[i][j];
      
    }
  }
  
  //order by row
  if(key == 'r')
  {
    removeColumnLabels = 0;
    for(int i = 0; i < YEARS; i++)
      yearL[i] = origYearL[i];
    
    for(int i = 0; i < numRows; i++)
    {
      labels[i] = origLabels[trackRowChanges[i]];
      
      for(int j = 0; j < numColumns; j++)
        drawMatrix[i][j] = dataMatrix[trackRowChanges[i]][j]; 
      
    }       
  }
  
  //order by column
  if(key == 'c')
  {
    removeColumnLabels = 1;
    
    for(int i = 0; i < numRows; i++)
    {
      labels[i] = origLabels[i];
      
      for(int j = 0; j < numColumns; j++)
        drawMatrix[i][j] = dataMatrix[i][trackColumnChanges[j]];
      
    }
  }
  
  //both: order by row and column
  if(key == 'b')
  {
    int [][] rowMatrix = null;
    rowMatrix = new int[numRows][numColumns];
    
    removeColumnLabels = 1;
    
    //order by row
    for(int i = 0; i < numRows; i++)
    {
      labels[i] = origLabels[trackRowChanges[i]];
      
      for(int j = 0; j < numColumns; j++)
        rowMatrix[i][j] = dataMatrix[trackRowChanges[i]][j]; //note difference here
      
    }
    
    //order by column
    for(int i = 0; i < numRows; i++)
      for(int j = 0; j < numColumns; j++)
        drawMatrix[i][j] = rowMatrix[i][trackColumnChanges[j]];
  }
  
  //grouped: columns grouped by year (order by column)
  if(key == 'g')
  {
    removeColumnLabels = 0;
    
    for(int i = 0; i < numRows; i++)
    {
      labels[i] = origLabels[i];

      for(int j = 0; j < YEARS; j++)
      {
        yearL[j] = origYearL[trackChunkChanges[j]];

        for(int v = 0; v < 12; v++)
          drawMatrix[i][(j * 12) + v] = dataMatrix[i][(trackChunkChanges[j] * 12) + v];
      }
    }   
  }
  
  //grouped: columns grouped by year (ordered by both rows and columns)
  if(key == 'G')
  {
    int [][] tempMatrix = null;
    tempMatrix = new int[numRows][numColumns];
    
    removeColumnLabels = 0;
    
    //order by chunky columns
    for(int i = 0; i < numRows; i++)
    {
      labels[i] = origLabels[i];

      for(int j = 0; j < YEARS; j++)
      {
        yearL[j] = origYearL[trackChunkChanges[j]];

        for(int v = 0; v < 12; v++)
          tempMatrix[i][(j * 12) + v] = dataMatrix[i][(trackChunkChanges[j] * 12) + v];
      }
    } 
    
    //order by rows
    for(int i = 0; i < numRows; i++)
    {
      labels[i] = origLabels[trackRowChanges[i]];
      
      for(int j = 0; j < numColumns; j++)
        drawMatrix[i][j] = tempMatrix[trackRowChanges[i]][j]; 
    }
    
  }

} //end key pressed

    
